"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof3 = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getMultiValue = exports["default"] = void 0;

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _useFieldApi2 = _interopRequireDefault(require("@data-driven-forms/react-form-renderer/use-field-api"));

var _select = _interopRequireDefault(require("@data-driven-forms/common/select"));

var _fnToString = _interopRequireDefault(require("@data-driven-forms/common/utils/fn-to-string"));

var _carbonComponentsReact = require("carbon-components-react");

var _prepareProps = _interopRequireDefault(require("../prepare-props"));

var _excluded = ["options"],
    _excluded2 = ["invalidText", "hideSelectedOptions", "noOptionsMessage", "onInputChange", "options", "isFetching", "invalid", "isMulti", "classNamePrefix", "closeMenuOnSelect", "onChange", "originalOnChange", "carbonLabel", "placeholder", "isDisabled"],
    _excluded3 = ["invalidText", "hideSelectedOptions", "noOptionsMessage", "onInputChange", "options", "isFetching", "invalid", "isMulti", "classNamePrefix", "closeMenuOnSelect", "onChange", "originalOnChange", "carbonLabel", "placeholder", "isDisabled"],
    _excluded4 = ["isSearchable", "isClearable", "isDisabled", "isMulti", "invalidText", "hideSelectedOptions", "noOptionsMessage", "onInputChange", "options", "isFetching", "invalid", "classNamePrefix", "closeMenuOnSelect", "originalOnChange", "placeholder", "value"],
    _excluded5 = ["isSearchable", "isClearable", "isDisabled", "isMulti", "invalidText", "hideSelectedOptions", "noOptionsMessage", "onInputChange", "options", "isFetching", "invalid", "classNamePrefix", "closeMenuOnSelect", "originalOnChange", "placeholder", "labelText", "onChange", "value"],
    _excluded6 = ["isMulti", "isSearchable", "isClearable", "loadOptions", "input", "meta", "validateOnMount", "helperText"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof3(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var onChangeWrapper = function onChangeWrapper(onChange) {
  return function (_ref) {
    var selectedItem = _ref.selectedItem,
        selectedItems = _ref.selectedItems;
    return onChange(selectedItems || selectedItem);
  };
};

var getMultiValue = function getMultiValue(value, options) {
  return (Array.isArray(value) ? value : value ? [value] : []).map(function (item) {
    return (0, _typeof2["default"])(item) === 'object' ? item : options.find(function (_ref2) {
      var value = _ref2.value;
      return value === item;
    });
  });
};

exports.getMultiValue = getMultiValue;

var renderOptions = function renderOptions(options) {
  return options.map(function (option, index) {
    var options = option.options,
        rest = (0, _objectWithoutProperties2["default"])(option, _excluded);

    if (options) {
      return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.SelectItemGroup, (0, _extends2["default"])({
        key: rest.value || index,
        text: rest.label
      }, rest), renderOptions(options));
    }

    return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.SelectItem, (0, _extends2["default"])({
      key: rest.value || index,
      text: rest.label
    }, rest));
  });
};

var ClearedMultiSelectFilterable = function ClearedMultiSelectFilterable(_ref3) {
  var invalidText = _ref3.invalidText,
      hideSelectedOptions = _ref3.hideSelectedOptions,
      noOptionsMessage = _ref3.noOptionsMessage,
      onInputChange = _ref3.onInputChange,
      options = _ref3.options,
      isFetching = _ref3.isFetching,
      invalid = _ref3.invalid,
      isMulti = _ref3.isMulti,
      classNamePrefix = _ref3.classNamePrefix,
      closeMenuOnSelect = _ref3.closeMenuOnSelect,
      onChange = _ref3.onChange,
      originalOnChange = _ref3.originalOnChange,
      carbonLabel = _ref3.carbonLabel,
      placeholder = _ref3.placeholder,
      isDisabled = _ref3.isDisabled,
      rest = (0, _objectWithoutProperties2["default"])(_ref3, _excluded2);
  return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.MultiSelect.Filterable, (0, _extends2["default"])({
    disabled: isDisabled
  }, rest, {
    placeholder: carbonLabel || placeholder,
    onChange: onChangeWrapper(onChange),
    titleText: rest.labelText,
    id: rest.name,
    invalid: Boolean(invalidText),
    invalidText: invalidText,
    items: options,
    initialSelectedItems: getMultiValue(rest.value, options)
  }));
};

ClearedMultiSelectFilterable.propTypes = {
  invalidText: _propTypes["default"].node,
  hideSelectedOptions: _propTypes["default"].any,
  noOptionsMessage: _propTypes["default"].any,
  onInputChange: _propTypes["default"].func,
  options: _propTypes["default"].array,
  isFetching: _propTypes["default"].bool,
  invalid: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].node]),
  isMulti: _propTypes["default"].bool,
  classNamePrefix: _propTypes["default"].any,
  closeMenuOnSelect: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  originalOnChange: _propTypes["default"].func,
  carbonLabel: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool
};

var ClearedMultiSelect = function ClearedMultiSelect(_ref4) {
  var invalidText = _ref4.invalidText,
      hideSelectedOptions = _ref4.hideSelectedOptions,
      noOptionsMessage = _ref4.noOptionsMessage,
      onInputChange = _ref4.onInputChange,
      options = _ref4.options,
      isFetching = _ref4.isFetching,
      invalid = _ref4.invalid,
      isMulti = _ref4.isMulti,
      classNamePrefix = _ref4.classNamePrefix,
      closeMenuOnSelect = _ref4.closeMenuOnSelect,
      onChange = _ref4.onChange,
      originalOnChange = _ref4.originalOnChange,
      carbonLabel = _ref4.carbonLabel,
      placeholder = _ref4.placeholder,
      isDisabled = _ref4.isDisabled,
      rest = (0, _objectWithoutProperties2["default"])(_ref4, _excluded3);
  return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.MultiSelect, (0, _extends2["default"])({
    disabled: isDisabled
  }, rest, {
    label: carbonLabel || placeholder,
    onChange: onChangeWrapper(onChange),
    titleText: rest.labelText,
    id: rest.name,
    invalid: Boolean(invalidText),
    invalidText: invalidText,
    items: options,
    initialSelectedItems: getMultiValue(rest.value, options)
  }));
};

ClearedMultiSelect.propTypes = {
  invalidText: _propTypes["default"].node,
  hideSelectedOptions: _propTypes["default"].any,
  noOptionsMessage: _propTypes["default"].any,
  onInputChange: _propTypes["default"].func,
  options: _propTypes["default"].array,
  isFetching: _propTypes["default"].bool,
  invalid: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].node]),
  isMulti: _propTypes["default"].bool,
  classNamePrefix: _propTypes["default"].any,
  closeMenuOnSelect: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  originalOnChange: _propTypes["default"].func,
  carbonLabel: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isRequired: _propTypes["default"].bool,
  isDisabled: _propTypes["default"].bool
};

var getSelectValue = function getSelectValue(value, isMulti) {
  return isMulti ? value : Array.isArray(value) ? value[0] : value;
};

var ClearedSelect = function ClearedSelect(_ref5) {
  var isSearchable = _ref5.isSearchable,
      isClearable = _ref5.isClearable,
      isDisabled = _ref5.isDisabled,
      isMulti = _ref5.isMulti,
      invalidText = _ref5.invalidText,
      hideSelectedOptions = _ref5.hideSelectedOptions,
      noOptionsMessage = _ref5.noOptionsMessage,
      onInputChange = _ref5.onInputChange,
      options = _ref5.options,
      isFetching = _ref5.isFetching,
      invalid = _ref5.invalid,
      classNamePrefix = _ref5.classNamePrefix,
      closeMenuOnSelect = _ref5.closeMenuOnSelect,
      originalOnChange = _ref5.originalOnChange,
      placeholder = _ref5.placeholder,
      value = _ref5.value,
      rest = (0, _objectWithoutProperties2["default"])(_ref5, _excluded4);
  return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.Select, (0, _extends2["default"])({
    value: getSelectValue(value, isMulti),
    disabled: isFetching
  }, rest, {
    id: rest.name,
    invalid: Boolean(invalidText),
    invalidText: invalidText
  }), isFetching && /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.SelectItem, {
    text: placeholder,
    value: ''
  }), renderOptions(options));
};

ClearedSelect.propTypes = {
  invalidText: _propTypes["default"].node,
  hideSelectedOptions: _propTypes["default"].any,
  noOptionsMessage: _propTypes["default"].any,
  onInputChange: _propTypes["default"].func,
  options: _propTypes["default"].array,
  isFetching: _propTypes["default"].bool,
  invalid: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].node]),
  isMulti: _propTypes["default"].bool,
  classNamePrefix: _propTypes["default"].any,
  closeMenuOnSelect: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  originalOnChange: _propTypes["default"].func,
  carbonLabel: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  isSearchable: _propTypes["default"].bool,
  isClearable: _propTypes["default"].bool,
  value: _propTypes["default"].any
};

var getComboInitialValue = function getComboInitialValue(value) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var result = Array.isArray(value) ? value[0] : value;
  return (0, _typeof2["default"])(result) === 'object' ? result : options.find(function (_ref6) {
    var value = _ref6.value;
    return value === result;
  }) || result;
};
/**
 * Combobox cannot be multi value
 */


var ClearedSelectSearchable = function ClearedSelectSearchable(_ref7) {
  var isSearchable = _ref7.isSearchable,
      isClearable = _ref7.isClearable,
      isDisabled = _ref7.isDisabled,
      isMulti = _ref7.isMulti,
      invalidText = _ref7.invalidText,
      hideSelectedOptions = _ref7.hideSelectedOptions,
      noOptionsMessage = _ref7.noOptionsMessage,
      onInputChange = _ref7.onInputChange,
      _ref7$options = _ref7.options,
      options = _ref7$options === void 0 ? [] : _ref7$options,
      isFetching = _ref7.isFetching,
      invalid = _ref7.invalid,
      classNamePrefix = _ref7.classNamePrefix,
      closeMenuOnSelect = _ref7.closeMenuOnSelect,
      originalOnChange = _ref7.originalOnChange,
      placeholder = _ref7.placeholder,
      labelText = _ref7.labelText,
      onChange = _ref7.onChange,
      value = _ref7.value,
      rest = (0, _objectWithoutProperties2["default"])(_ref7, _excluded5);
  return /*#__PURE__*/_react["default"].createElement(_carbonComponentsReact.ComboBox, (0, _extends2["default"])({
    disabled: isFetching
  }, rest, {
    id: rest.name,
    invalid: Boolean(invalidText),
    invalidText: invalidText,
    initialSelectedItem: getComboInitialValue(value, options),
    items: options,
    placeholder: placeholder,
    titleText: labelText,
    onChange: onChangeWrapper(onChange)
  }));
};

ClearedSelectSearchable.propTypes = {
  invalidText: _propTypes["default"].node,
  hideSelectedOptions: _propTypes["default"].any,
  noOptionsMessage: _propTypes["default"].any,
  onInputChange: _propTypes["default"].func,
  options: _propTypes["default"].array,
  isFetching: _propTypes["default"].bool,
  invalid: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].node]),
  isMulti: _propTypes["default"].bool,
  classNamePrefix: _propTypes["default"].any,
  closeMenuOnSelect: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  originalOnChange: _propTypes["default"].func,
  carbonLabel: _propTypes["default"].node,
  placeholder: _propTypes["default"].node,
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  isSearchable: _propTypes["default"].bool,
  isClearable: _propTypes["default"].bool,
  labelText: _propTypes["default"].string,
  value: _propTypes["default"].any
};

var Select = function Select(props) {
  var _useFieldApi = (0, _useFieldApi2["default"])((0, _prepareProps["default"])(props)),
      isMulti = _useFieldApi.isMulti,
      isSearchable = _useFieldApi.isSearchable,
      isClearable = _useFieldApi.isClearable,
      loadOptions = _useFieldApi.loadOptions,
      input = _useFieldApi.input,
      meta = _useFieldApi.meta,
      validateOnMount = _useFieldApi.validateOnMount,
      helperText = _useFieldApi.helperText,
      rest = (0, _objectWithoutProperties2["default"])(_useFieldApi, _excluded6);

  var _useState = (0, _react.useState)(0),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      loadOptionsChangeCounter = _useState2[0],
      setCounter = _useState2[1];

  var loadOptionsStr = (0, _fnToString["default"])(loadOptions);
  (0, _react.useEffect)(function () {
    setCounter(loadOptionsChangeCounter + 1); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [loadOptionsStr]);
  var isSearchClear = isSearchable || isClearable;
  var Component = ClearedSelect;

  if (isMulti && isSearchClear) {
    Component = ClearedMultiSelectFilterable;
  } else if (isMulti) {
    Component = ClearedMultiSelect;
  } else if (isSearchClear) {
    Component = ClearedSelectSearchable;
  }

  var invalidText = (meta.touched || validateOnMount) && (meta.error || meta.submitError) || '';
  var text = (meta.touched || validateOnMount) && meta.warning || helperText;
  return /*#__PURE__*/_react["default"].createElement(_select["default"], (0, _extends2["default"])({
    SelectComponent: Component,
    simpleValue: false
  }, rest, input, {
    isMulti: isMulti,
    loadOptions: loadOptions,
    invalidText: invalidText,
    loadOptionsChangeCounter: loadOptionsChangeCounter,
    helperText: text
  }));
};

Select.propTypes = {
  isDisabled: _propTypes["default"].bool,
  isRequired: _propTypes["default"].bool,
  options: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    value: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].number]),
    label: _propTypes["default"].node
  }))
};
Select.defaultProps = {
  loadingMessage: 'Loading...'
};
var _default = Select;
exports["default"] = _default;